<template>
  <div>
    <BeneficiaryHistoryFilters
      :is-in-interviews-context="true"
      :is-in-help-requests-context="true"
      @filter="onFilter"
    />
    <hr />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      :message="error"
    />
    <template v-else>
      <template v-if="!history.length">
        <p v-if="!filters">
          Créez une synthèse d'entretien pour commencer à alimenter l'historique
          du bénéficiaire.
        </p>
        <p v-else>Aucun résultat ne correspond aux filtres sélectionnés.</p>
      </template>
      <template v-else>
        <p class="fr-mb-2w fr-hint-text">
          {{ history.length }} élément(s) de l'historique du bénéficiaire
          affiché(s)
        </p>
        <ul class="history-list">
          <BeneficiaryHistoryDetails
            v-for="historyItem in history"
            :key="historyItem.id"
            :history="historyItem"
            :unread-notifications="unreadHistoryNotifications"
            @deleted="() => onHistoryItemDeleted(historyItem.isInterview)"
          />
        </ul>
      </template>
    </template>
  </div>
</template>

<script setup>
  import { useFiltersStore } from '~/store/filters'
  import {
    INTERVIEWS_COLLECTION,
    HELP_REQUESTS_COLLECTION
  } from '~/utils/constants/history'
  import { sortHistoryItems } from '~/utils/sortHistoryItems'
  import { getRandomId } from '~~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { BeneficiaryTab } from '~~/utils/constants/beneficiary-tabs'

  const { $getItems, $focusAndScrollTo } = useNuxtApp()
  const filtersStore = useFiltersStore()
  const route = useRoute()

  const props = defineProps({
    beneficiaryId: { type: String, required: true }
  })

  const {
    data: interviews,
    pending: interviewsPending,
    error: interviewsError,
    refresh: interviewsRefresh
  } = useLazyAsyncData(getRandomId('interviews'), loadInterviews, {
    server: false,
    default: () => []
  })

  const {
    data: helpRequests,
    pending: helpRequestsPending,
    error: helpRequestsError,
    refresh: helpRequestsRefresh
  } = useLazyAsyncData(getRandomId('helpRequests'), loadHelpRequests, {
    server: false,
    default: () => []
  })

  const { data: unreadHistoryNotifications } = useLazyAsyncData(
    getRandomId(`unreadHistoryNotifications`),
    loadUnreadHistoryNotifications,
    { server: false, default: () => [] }
  )

  const filters = ref(filtersStore.beneficiaryHistory.directusQuery)

  const history = computed(() =>
    [
      ...interviews.value.map(i => ({ ...i, isInterview: true })),
      ...helpRequests.value.map(hr => ({ ...hr, isInterview: false }))
    ].sort(sortHistoryItems)
  )

  const pending = computed(
    () => interviewsPending.value || helpRequestsPending.value
  )

  const error = computed(() => {
    if (interviewsError.value || helpRequestsError.value) {
      return "L'historique du bénéficiaire n'a pas pu être chargé."
    }
    return ''
  })

  watch(
    [pending, error, () => route.query.tab, () => route.query.item],
    async ([_pending, _error, tab, item]) => {
      if (_pending || _error) return

      await nextTick()

      if (tab === BeneficiaryTab.History && item) {
        $focusAndScrollTo(`#history-${item}`)
      }
    },
    { deep: true }
  )

  async function loadInterviews() {
    const query = {
      fields: [
        '*',
        'user_created.id',
        'user_created.first_name',
        'user_created.last_name',
        'organisme_prescripteur.name',
        'follow_up_types.follow_up_types_id.id',
        'follow_up_types.follow_up_types_id.type',
        'follow_up_types.follow_up_types_id.name',
        'private_synthesis.private_synthesis',
        'documents.directus_file.id',
        'documents.directus_file.filename_download',
        'comments.*',
        'comments.user_created.first_name',
        'comments.user_created.last_name'
      ],
      sort: [{ field: 'date', sort: '-' }],
      filter: { beneficiary: { id: props.beneficiaryId } }
    }
    if (filters.value) {
      query.filter = { ...query.filter, ...filters.value.interviewFilters }
    }

    const res = await $getItems('follow_ups', query)

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  async function loadHelpRequests() {
    const query = {
      fields: [
        '*',
        'user_created.id',
        'user_created.first_name',
        'user_created.last_name',
        'follow_up_type.id',
        'follow_up_type.type',
        'follow_up_type.name',
        'private_synthesis.private_synthesis',
        'documents.directus_file.id',
        'documents.directus_file.filename_download',
        'comments.*',
        'comments.user_created.first_name',
        'comments.user_created.last_name',
        'organisme_prescripteur.name',
        'organisme_instructeur.name'
      ],
      sort: [{ field: 'opening_date', sort: '-' }],
      filter: { beneficiary: { id: props.beneficiaryId } }
    }
    if (filters.value) {
      query.filter = { ...query.filter, ...filters.value.helpRequestFilters }
    }

    const res = await $getItems('help_requests', query)

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  async function onFilter({ interviewFilters, helpRequestFilters, typeSuivi }) {
    filters.value = { interviewFilters, helpRequestFilters }
    helpRequests.value = []
    interviews.value = []
    const hasInterviewFilters =
      interviewFilters && Object.keys(interviewFilters).length
    const hasHelpRequestFilters =
      helpRequestFilters && Object.keys(helpRequestFilters).length
    const hasNoFilters =
      !hasInterviewFilters && !hasHelpRequestFilters && !typeSuivi
    const filterPromises = []

    if (
      hasInterviewFilters ||
      typeSuivi === INTERVIEWS_COLLECTION ||
      hasNoFilters
    ) {
      filterPromises.push(interviewsRefresh())
    }

    if (
      hasHelpRequestFilters ||
      typeSuivi === HELP_REQUESTS_COLLECTION ||
      hasNoFilters
    ) {
      filterPromises.push(helpRequestsRefresh())
    }

    await Promise.all(filterPromises)
  }

  async function loadUnreadHistoryNotifications() {
    const query = {
      fields: 'item.item.id',
      filter: {
        _or: [
          {
            item: {
              'item:follow_ups': {
                beneficiary: { id: { _eq: props.beneficiaryId } }
              }
            }
          },
          {
            item: {
              'item:help_requests': {
                beneficiary: { id: { _eq: props.beneficiaryId } }
              }
            }
          }
        ],
        read: { _eq: false }
      }
    }

    const res = await $getItems('notifications', query)

    if (res.status === 200) {
      return res.data.data.map(({ item }) => item[0].item.id)
    }
    throw new Error(errorResponseMessage(res))
  }

  function onHistoryItemDeleted(isInterview) {
    if (isInterview) {
      interviewsRefresh()
    } else {
      helpRequestsRefresh()
    }
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;

  .history-list {
    @include dsfr.disable-list-style;

    > *:not(:last-child) {
      margin-bottom: 2rem;
    }
  }
</style>
